package Chimera::Object;

use strict;
use vars qw($BOLD $RESET);

BEGIN {
	eval qq{ use Term::ANSIColor; };
	if ($@) {
		warn "The output from this program is more readable if you " .
				"have Term::ANSIColor installed. Continuing anyway...";
		*Chimera::Object::color = sub { ""; };
	}
}

$BOLD = color 'cyan';
$RESET = color 'reset';

sub new {
	my $class = shift;
	my $self = ($#_ == 0) ? { %{ (shift) } } : { @_ };
	return bless $self, $class;
}

sub display {
	my ($self, $level, $msg, $data) = @_;
	return unless $level <= $self->{Verbose};
	$data = substr($data, 0, 50) . "..." if length($data) > 50;
	$data =~ s/(...)(...)/$1$BOLD$2$RESET/g;
	print STDERR "$self->{Name}\[$level] ($msg): $data\n";
}

1;
