package Chimera::World;

use strict;
use vars qw(@ISA);
use Data::Dumper;
use Chimera::Object;

@ISA = qw(Chimera::Object);

sub new {
	my $class = shift;
	my $self = $class->SUPER::new(@_);
	die "No name for world" unless $self->{Name};
	$self->{Round} = 0;
	$self->{Verbose} = 5 unless exists $self->{Verbose};

	$self->display(1, "new world, verbosity " . $self->{Verbose}, "");

	return $self;
}

sub register {
	my $self = shift;
	push(@{ $self->{Users} }, @_);
}

sub round {
	my $self = shift;
	$self->display(1, "round", $self->{Round});
	my @out = map { $_->round(@_) } @{ $self->{Users} };
	$self->{Round} = $self->{Round} + 1;
	map { $_->clean } @{ $self->{Users} };
	return @out;
}

sub event {
	my $self = shift;
	return map { $_->event(@_) } @{ $self->{Users} };
}

sub run {
	my $self = shift;
	die "No Rounds in world" unless $self->{Rounds};

	foreach (1..$self->{Rounds}) {
		$self->round;
	}
}

1;
